//
//  algorithms.hpp
//  
//
//  Created by Bernardo on 07/09/12.
//
//

#ifndef _algorithms_hpp
#define _algorithms_hpp

#include <vector>
#include <algorithm>
#include <cmath>
#include "./mt19937ar.h"

using namespace std;

template <class container>
double average(container v){
    double avg = 0;
    for(int i = 0; i < v.size();i++) avg += v[i];
    return avg/v.size();
}


template <class container>
double std_dev(container v){
    double avg = 0,fluct = 0;
    for(int i = 0; i < v.size();i++) avg += v[i];
    avg =  avg/v.size();
    
    for(int i = 0; i < v.size();i++) fluct += (v[i] - avg)*(v[i] - avg);
    fluct = sqrt(fluct/(v.size()-1));
    
    return fluct;
}

void doubleBubbleSort(vector <int> *num, vector<int> *paral)
{

    if(num->size()==1) return;

      int i, j, flag = 1;    // set flag to 1 to start first pass
      int temp;             // holding variable
      int numLength = (*num).size( ); 
      for(i = 1; (i <= numLength) && flag; i++)
     {
          flag = 0;
          for (j=0; j < (numLength -1); j++)
         {
               if ((*num)[j+1] > (*num)[j])      // ascending order simply changes to <
              { 
                    temp = (*num)[j];             // swap elements
                    (*num)[j] = (*num)[j+1];
                    (*num)[j+1] = temp;

		    temp = (*paral)[j];
		    (*paral)[j] = (*paral)[j+1];
		    (*paral)[j+1] = temp;

                    flag = 1;               // indicates that a swap occurred.
               }
          }
     }
     return;   //arrays are passed to functions by address; nothing is returned
}

int u(int n){
	return int(n*(genrand_real3()));
}

double u(){
	return genrand_real3();
}


inline double fastPow(double a, double b) {
  union {
    double d;
    int x[2];
  } u = { a };
  u.x[1] = (int)(b * (u.x[1] - 1072632447) + 1072632447);
  u.x[0] = 0;
  return u.d;
}

#endif
