//
//  main.cpp
//  network_dynamics
//
//  Created by Bernardo on 06/09/12.
//  Copyright (c) 2012 Bernardo. All rights reserved.
//

#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <functional>
#include <vector>
#include <numeric>
#include <sys/time.h>
#include <ctime>
#include <string>
#include "urn_graph.hpp"
#include <sstream>


using namespace std;

int main(int argc, const char * argv[])
{

	if(argc < 2){
		cout << "Missing parameter [gamma] assuming is 0.005\n";
		double gamma = 0.005;
	}
	else {
		double gamma = atof(argv[1]);
	}

	double t_max = 10000000;
	double p = 0.001;//0.01


	double rho = 2;//1
	double nu = 15;
	int n0 =1;
	double N0=n0*(nu+1);

	cout << "rho = "<< rho <<  " eta = " << p  << " gamma = " << gamma << " nu = " << nu << endl;

	int n_realiz = 1;
	Urn U(N0,p,gamma, nu, rho,1);
	vector<int> S;

	for(int i = 0; i < n_realiz; i++){

		int ball = U.get_starting_ball();
		S.push_back(ball);
		cout << "t: " << 0 << " palla estratta: " << ball << " dimensione urna " << U.get_balls_number() << endl;
		for(int t = 1; t < t_max; t++){
			ball = U.get_ball(ball,t);
			S.push_back(ball);
			if(t%10000==0)cout << "t: " << t << " palla estratta: " << ball << " dimensione urna " << U.get_balls_number()
				<< " max_w " << U.get_max_weight() << " zero element adj size = " << U.print_adj_number(0)
			   << " D = " << U.get_exited_balls()  << endl;

			if(t%10000==0){
						stringstream ss_res;
						ss_res << "./results/";
						ss_res << "results_" << nu << "_" << rho << "_" << gamma << "_" << n0 <<".txt";
						string aux2 = ss_res.str();
						char *output_res = &aux2[0];


						ofstream out_res(output_res);
						for(int tt = 0; tt < t; tt++) out_res << S[tt] << "\t";
						out_res << endl;
						out_res.close();

						vector<int> labels = U.get_labels();
						stringstream ss_lab;
						ss_lab << "./results/";
						ss_lab << "labels_" << nu << "_" << rho << "_" << gamma << "_" << n0 <<".txt";
						aux2 = ss_lab.str();
						char *output_lab = &aux2[0];

						ofstream out_lab(output_lab);
						for(int i = 0; i < labels.size(); i++) out_lab << labels[i] << "\t";
						out_lab << endl;
						out_lab.close();
			}


		}


		stringstream ss_res;
		ss_res << "./results/";
		ss_res << "results_" << nu << "_" << rho << "_" << gamma << "_" << n0 <<".txt";
		string aux2 = ss_res.str();
		char *output_res = &aux2[0];


		ofstream out_res(output_res);
		for(int t = 0; t < t_max; t++) out_res << S[t] << "\t";
		out_res << endl;
		out_res.close();

		vector<int> labels = U.get_labels();
		stringstream ss_lab;
		ss_lab << "./results/";
		ss_lab << "labels_" << nu << "_" << rho << "_" << gamma << "_" << n0 <<".txt";
		aux2 = ss_lab.str();
		char *output_lab = &aux2[0];

		ofstream out_lab(output_lab);
		for(int i = 0; i < labels.size(); i++) out_lab << labels[i] << "\t";
		out_lab << endl;
		out_lab.close();


		S.clear();
		U.reset(N0);

	}

	return 0;

}
