#ifndef URN_HPP
#define URN_HPP

#include <algorithm>
#include <iostream>
#include <vector>
#include <sys/time.h>
#include <ctime>
#include <random>
#include <set>
#include <map>

using namespace std;

class Urn{
private:
	int N_balls;
	int N_links;
	double p, gamma;
	double nu, rho;
	vector<int> balls;
	vector<int> children_number;
	vector<int> creation_time;
	vector<int> last_visit;

	vector<int> sources;
	vector<int> labels;
	vector<int> labels_count;

	vector<double> weights;
	vector< vector<int> > adj_list;
	vector<bool> exited;
	default_random_engine engine;

public:
	Urn(int N0, double p0, double gamma0,  double Nu, double Rho, double Rho0);
	~Urn();
	void add_ball(int source);
	void set_random_links(int c);
	void set_random_links_full(int c);
	int get_ball(int c, int t);
	int get_starting_ball();
	void reinforce_ball(int c, double w);
	int print_adj_number(int c);
	int get_balls_number();
	int get_exited_balls();
	double get_max_weight();
	void reset(int N0);
	vector<int> get_labels();

};

#endif